//+------------------------------------------------------------------+
//|                                                     MA cross.mq4 |
//|                        Copyright 2012, www.forex-programming.com |
//|                                        www.forex-programming.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, www.forex-programming.com"
#property link      "www.forex-programming.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Aqua

extern string pi="--- Alert settings ---";
extern bool   Terminal_Alert_ON=true,
              Email_Alert_ON=true;

extern string pi1="--- Fast MA settings ---";
extern string pi11=" // MA period // ";
extern int    Fast_MA_Period = 5 ;
extern string pi12=" // MA shift // ";
extern int    Fast_MA_Shift = 0 ;
extern string pi13=" // MA method // ";
extern string pi14="SMA=0, EMA=1, SMMA=2, LWMA=3";
extern int    Fast_MA_Method = 1 ;
extern string pi15=" // MA apply to // ";
extern string pi16="Close=0, Open=1, High=2, Low=3";
extern string pi17="Median=4, Typical=5, Weighted=6";
extern int    Fast_MA_Apply = 0 ;

extern string pi2="--- Slow MA settings ---";
extern string pi21=" // MA period // ";
extern int    Slow_MA_Period = 11 ;
extern string pi22=" // MA shift // ";
extern int    Slow_MA_Shift = 0 ;
extern string pi23=" // MA method // ";
extern string pi24="SMA=0, EMA=1, SMMA=2, LWMA=3";
extern int    Slow_MA_Method = 0 ;
extern string pi25=" // MA apply to // ";
extern string pi26="Close=0, Open=1, High=2, Low=3";
extern string pi27="Median=4, Typical=5, Weighted=6";
extern int    Slow_MA_Apply = 0 ;

double        Fast[], Slow[];
datetime      New_Time=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   Comment("www.forex-programming.com");
   
   SetIndexBuffer(0, Fast);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexLabel(0, "Fast MA");
   SetIndexBuffer(1, Slow);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexLabel(1, "Slow MA");
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars;
   if (limit<0) limit=0;
   
   // define MAs values
   for (int i=limit; i>=0; i--)
      {
       Fast[i]=iMA(NULL, 0, Fast_MA_Period, Fast_MA_Shift, Fast_MA_Method, Fast_MA_Apply, i);
       Slow[i]=iMA(NULL, 0, Slow_MA_Period, Slow_MA_Shift, Slow_MA_Method, Slow_MA_Apply, i);
      }
   /*
   Terminal_Alert_ON=true,
   Email_Alert_ON=true;
   
   if (EMail)
            {
             string alertText = TimeToStr(Time[0], TIME_DATE || TIME_MINUTES )+" "+comm+" "+Symbol()+" "+TFName(Period())+ " at " + DoubleToStr(Bid, Digits);
             SendMail("Main Signal EA, "+Symbol()+" "+TFName(Period()), alertText);
            }
   */
   // Alert
   if (New_Candle() && (Terminal_Alert_ON || Email_Alert_ON))
      {
       string comm;
       // buy alert
       if (Fast[1]>=Slow[1] && Fast[2]<=Slow[2])
         {
          comm=Symbol()+" "+TFName(Period())+" "+TimeToStr(Time[0], TIME_DATE | TIME_MINUTES )+", BUY SIGNAL: Fast MA cross Slow MA from down to up at " + DoubleToStr(Bid, Digits);
          if (Terminal_Alert_ON) Alert(comm);
          if (Email_Alert_ON) SendMail("MA cross indicator BUY signal", comm);
         }
       // sell alert
       if (Fast[1]<=Slow[1] && Fast[2]>=Slow[2])
         {
          comm=Symbol()+" "+TFName(Period())+" "+TimeToStr(Time[0], TIME_DATE | TIME_MINUTES )+", SELL SIGNAL: Fast MA cross Slow MA from up to down at " + DoubleToStr(Bid, Digits);
          if (Terminal_Alert_ON) Alert(comm);
          if (Email_Alert_ON) SendMail("MA cross indicator SELL signal", comm);
         }
      }
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Define new candle                                                |
//+------------------------------------------------------------------+
bool New_Candle()
  {
   if (New_Time!=Time[0])
     {
      New_Time=Time[0];
      return(true);
     }
    else
     {
      return(false);
     }
  }

//+------------------------------------------------------------------+
//| Period to String                                                 |
//+------------------------------------------------------------------+
string TFName( int tf )
{
   switch(tf) {
      case PERIOD_M1: return("M1"); break;
		case PERIOD_M5: return("M5"); break;
		case PERIOD_M15: return("M15"); break;
		case PERIOD_M30: return("M30"); break;
		case PERIOD_H1: return("H1"); break;
		case PERIOD_H4: return("H4"); break;
		case PERIOD_D1: return("Daily"); break;
		case PERIOD_W1: return("Weekly"); break;
		case PERIOD_MN1: return("Monthly"); break;
		default: return(TFName(Period()));
	}
	
	return;
}